<template>
  <div class="citySearch">
    <div
      :class="{ 'inputComposite': composite, '-not-empty': opened || hasValue, '-invalid': classes['-invalid'] }"
      class="input">
      <AppSelect
        v-model="city"
        :max-height="200"
        :options="locations || []"
        :searchable="true"
        :placeholder="!composite ? placeholder : ''"
        class="input-field"
        @open="onOpen"
        @clear="onClear"
        @close="onClose"
        @select="onSelect">
        <template
          slot="option"
          slot-scope="{ option }">
          {{ option.name }}{{ option.parent ? `. ${option.parent.name}` : '' }}
        </template>
        <template slot="noResult">
          Укажите название вашего города, а после выберите его в списке.
        </template>
      </AppSelect>
      <span
        v-if="composite"
        class="inputComposite-label">
        Ваш город <sup class="__red">*</sup>
      </span>
    </div>
  </div>
</template>

<script>
import AppSelect from '~/components/redesign/app-select/app-select';

import { GeoLevel } from '~/backend/api-bundle/graphql/types';

export default {
  name: 'AppCitySearch',
  components: {
    AppSelect,
  },
  props: {
    value: {
      type: Object,
      default: null,
    },
    classes: {
      type: Object,
      default() { return {}; },
    },
    placeholder: {
      type: String,
      default: '',
    },
    composite: {
      type: Boolean,
      default: true,
    },
  },
  data() {
    return {
      locations: [],
      loading: true,
      opened: false,
      hasValue: false,
    };
  },
  computed: {
    city: {
      get() {
        return (this.value && this.value.name && this.value.id) && this.value;
      },
      set(val) {
        this.$emit('input', val || null);
      },
    },
  },
  async mounted() {
    if (this.city) {
      this.hasValue = true;
    }
    this.locations = await this.$axios.$get('/_main/geo/list', { params: { level: GeoLevel.City } })
      .then(response => response.data)
      .catch(e => console.error(e));
    this.loading = false;
  },
  methods: {
    onSelect(value) {
      this.$emit('input', value);
      this.hasValue = true;
    },
    onOpen() {
      this.opened = true;
    },
    onClose() {
      this.opened = false;
    },
    onClear() {
      this.hasValue = false;
      this.$emit('input', null);
    },
  },
};
</script>

<style lang="postcss">
.citySearch {
  position: relative;
  .multiselect__tags,
  .multiselect__input {
    border: none !important;
    background-color: #fff !important;
    box-shadow: none !important;
    outline: none;
    padding: 0;
    margin: 0;
  }
  .multiselect.multiselect--selected .multiselect__tags:after {
    display: none;
  }
  .multiselect.input-field.multiselect--selected {
    background-color: #fff;
  }
  .multiselect.input-field.multiselect--active {
    box-shadow: inset 0 0 0 1px var(--form-focus-border-color);
  }
  .multiselect__content-wrapper {
    right: 0;
  }
  .input-field {
    line-height: 1.5;
  }
  .inputComposite {
    position: static;
    &-label {
      z-index: 2;
    }
    .input-field {
      line-height: 1;
    }
  }
}
</style>
